/**
Copyright: 2024 Contrast Security, Inc
  Contact: support@contrastsecurity.com
  License: Commercial

  NOTICE: This Software and the patented inventions embodied within may only be
  used as part of Contrast Security’s commercial offerings. Even though it is
  made available through public repositories, use of this Software is subject to
  the applicable End User Licensing Agreement found at
  https://www.contrastsecurity.com/enduser-terms-0317a or as otherwise agreed
  between Contrast Security and the End User. The Software may not be reverse
  engineered, modified, repackaged, sold, redistributed or otherwise used in a
  way not consistent with the End User License Agreement.
*/
'use strict';
const { INPUT_TYPES } = require('../../constants');
const { emitSourceEvent } = require('../../hooks/frameworks/common');
const agentEmitter = require('../../agent-emitter');
const {
  constants: { EVENTS }
} = require('../../core/fastify');
const isContrastError = require('../../util/is-contrast-error');
const blockRequest = require('../../util/block-request');
const logger = require('../../core/logger')('hooks:fastify');

const id = 'fastify';

class FastifyProtectSources {
  constructor() {
    agentEmitter.on(
      EVENTS.PRE_VALIDATION,
      this.registerSourceHandler.bind(this)
    );
  }

  /**
   * Registers a handler that will emit all the source events for fastify
   * when the onPreValidation hook point in fastify occurs
   * @param {Fastify.Request} request incoming request
   * @param {Fastify.Reply}   reply   unbuilt outgoing response
   */
  registerSourceHandler(request, reply) {
    try {
      emitSourceEvent(
        request,
        request.raw,
        request.res,
        'query',
        INPUT_TYPES.QUERYSTRING,
        id
      );

      emitSourceEvent(
        request,
        request.raw,
        request.res,
        'params',
        INPUT_TYPES.URL_PARAMETER,
        id
      );

      emitSourceEvent(
        request,
        request.raw,
        request.res,
        'body',
        INPUT_TYPES.BODY,
        id
      );

      emitSourceEvent(
        request,
        request.raw,
        request.res,
        'cookies',
        INPUT_TYPES.COOKIE_VALUE,
        id
      );
    } catch (err) {
      if (isContrastError(err)) {
        blockRequest(reply.res);
        return;
      }

      logger.error('error emitting fastify source events %o', err);
    }
  }
}

module.exports = FastifyProtectSources;
